#include "sam5_sw_crc8.h"
#include <stdio.h>

const uint8_t sam5_sw_crc8_CrcTable[256] = {
	0x00, 0x4D, 0x9A, 0xD7, 0x79, 0x34, 0xE3, 0xAE, 0xF2, 0xBF, 0x68, 0x25, 0x8B, 0xC6,
	0x11, 0x5C, 0xA9, 0xE4, 0x33, 0x7E, 0xD0, 0x9D, 0x4A, 0x07, 0x5B, 0x16, 0xC1, 0x8C,
	0x22, 0x6F, 0xB8, 0xF5, 0x1F, 0x52, 0x85, 0xC8, 0x66, 0x2B, 0xFC, 0xB1, 0xED, 0xA0,
	0x77, 0x3A, 0x94, 0xD9, 0x0E, 0x43, 0xB6, 0xFB, 0x2C, 0x61, 0xCF, 0x82, 0x55, 0x18,
	0x44, 0x09, 0xDE, 0x93, 0x3D, 0x70, 0xA7, 0xEA, 0x3E, 0x73, 0xA4, 0xE9, 0x47, 0x0A,
	0xDD, 0x90, 0xCC, 0x81, 0x56, 0x1B, 0xB5, 0xF8, 0x2F, 0x62, 0x97, 0xDA, 0x0D, 0x40,
	0xEE, 0xA3, 0x74, 0x39, 0x65, 0x28, 0xFF, 0xB2, 0x1C, 0x51, 0x86, 0xCB, 0x21, 0x6C,
	0xBB, 0xF6, 0x58, 0x15, 0xC2, 0x8F, 0xD3, 0x9E, 0x49, 0x04, 0xAA, 0xE7, 0x30, 0x7D,
	0x88, 0xC5, 0x12, 0x5F, 0xF1, 0xBC, 0x6B, 0x26, 0x7A, 0x37, 0xE0, 0xAD, 0x03, 0x4E,
	0x99, 0xD4, 0x7C, 0x31, 0xE6, 0xAB, 0x05, 0x48, 0x9F, 0xD2, 0x8E, 0xC3, 0x14, 0x59,
	0xF7, 0xBA, 0x6D, 0x20, 0xD5, 0x98, 0x4F, 0x02, 0xAC, 0xE1, 0x36, 0x7B, 0x27, 0x6A,
	0xBD, 0xF0, 0x5E, 0x13, 0xC4, 0x89, 0x63, 0x2E, 0xF9, 0xB4, 0x1A, 0x57, 0x80, 0xCD,
	0x91, 0xDC, 0x0B, 0x46, 0xE8, 0xA5, 0x72, 0x3F, 0xCA, 0x87, 0x50, 0x1D, 0xB3, 0xFE,
	0x29, 0x64, 0x38, 0x75, 0xA2, 0xEF, 0x41, 0x0C, 0xDB, 0x96, 0x42, 0x0F, 0xD8, 0x95,
	0x3B, 0x76, 0xA1, 0xEC, 0xB0, 0xFD, 0x2A, 0x67, 0xC9, 0x84, 0x53, 0x1E, 0xEB, 0xA6,
	0x71, 0x3C, 0x92, 0xDF, 0x08, 0x45, 0x19, 0x54, 0x83, 0xCE, 0x60, 0x2D, 0xFA, 0xB7,
	0x5D, 0x10, 0xC7, 0x8A, 0x24, 0x69, 0xBE, 0xF3, 0xAF, 0xE2, 0x35, 0x78, 0xD6, 0x9B,
	0x4C, 0x01, 0xF4, 0xB9, 0x6E, 0x23, 0x8D, 0xC0, 0x17, 0x5A, 0x06, 0x4B, 0x9C, 0xD1,
	0x7F, 0x32, 0xE5, 0xA8
};

const uint8_t sam5_sw_crc8_EccTable[256] = {
	0xF0, 0xF0, 0xF0, 0xE7, 0xF0, 0xCE, 0xD8, 0xA3, 0xF0, 0x8A, 0xCF, 0x63, 0xD9, 0xC4,
	0xA4, 0xB5, 0xF0, 0x9C, 0x8B, 0x46, 0xC0, 0x56, 0x64, 0xAB, 0xDA, 0x6C, 0xC5, 0x71,
	0xA5, 0x4A, 0xB6, 0xED, 0xF0, 0xD4, 0x9D, 0x77, 0x8C, 0x5B, 0x47, 0x31, 0xC1, 0xCB,
	0x57, 0x53, 0x65, 0x58, 0xAC, 0x2A, 0xDB, 0x16, 0x6D, 0x83, 0xC6, 0x2D, 0x72, 0xE2,
	0xA6, 0x92, 0x4B, 0x00, 0xB7, 0xAF, 0xEE, 0x3D, 0xF0, 0x24, 0xD5, 0x22, 0x9E, 0xD7,
	0x68, 0x96, 0x8D, 0x26, 0x5C, 0x79, 0x38, 0xE8, 0x32, 0x1F, 0xC2, 0x88, 0xCC, 0xFF,
	0x48, 0x6A, 0x54, 0x9A, 0x66, 0xC9, 0x59, 0xD2, 0xAD, 0x90, 0x2B, 0x14, 0xDC, 0x7B,
	0x17, 0xBB, 0x6E, 0x5E, 0x84, 0x04, 0xC7, 0x18, 0x2E, 0xFF, 0x73, 0x8F, 0xE3, 0x42,
	0xA7, 0x11, 0x93, 0x1C, 0x4C, 0x34, 0x01, 0x4F, 0xA8, 0xEA, 0xA0, 0xB2, 0xEF, 0x3A,
	0x3E, 0x37, 0xF0, 0x1E, 0x25, 0x78, 0xD6, 0x95, 0x23, 0x21, 0x9F, 0x13, 0xC8, 0xD1,
	0x69, 0x99, 0x97, 0xFF, 0x8E, 0x41, 0x27, 0xFF, 0x5D, 0x03, 0x7A, 0xBA, 0x39, 0x36,
	0xE9, 0xB1, 0x33, 0x4E, 0x10, 0x1B, 0xC3, 0xB4, 0x89, 0x62, 0xCD, 0xA2, 0xFF, 0xE6,
	0x49, 0xEC, 0x6B, 0x70, 0x55, 0xAA, 0x9B, 0x45, 0x67, 0x29, 0xCA, 0x52, 0x5A, 0x30,
	0xD3, 0x76, 0xAE, 0x3C, 0x91, 0x0F, 0x2C, 0xE1, 0x15, 0x82, 0xDD, 0xBD, 0x7C, 0x0B,
	0x08, 0x09, 0xBC, 0x0A, 0x6F, 0x7D, 0x5F, 0x0C, 0x85, 0xDE, 0x05, 0xBE, 0xB8, 0x06,
	0x19, 0xBF, 0x2F, 0x86, 0xFF, 0xDF, 0x74, 0x50, 0x80, 0x0D, 0xE4, 0x60, 0x43, 0x7E,
	0x98, 0xFF, 0x12, 0xD0, 0x94, 0x20, 0x1D, 0x87, 0x4D, 0x1A, 0x35, 0xB0, 0x02, 0xB9,
	0x40, 0x07, 0xA9, 0x44, 0xEB, 0x7F, 0xA1, 0xE5, 0xB3, 0x61, 0xE0, 0x81, 0x3B, 0x0E,
	0x3F, 0x75, 0x28, 0x51
};

uint8_t sam5_sw_crc8_Applied(volatile uint8_t *data, volatile uint32_t length, uint8_t crcTransmitted) {
	const uint8_t crcCalculated = sam5_sw_crc8_CRC(data, length);
	if (crcCalculated == crcTransmitted) {
		return 0xFF;
	}
	if (length > SAM5_CRC8_MAX_DATA_LENGTH) {
		return 0;
	}

	const uint8_t diff = crcCalculated ^ crcTransmitted;
	if (sam5_sw_crc8_EccTable[diff] == 0xF0) {
		// No Error or only 1-bit error in CRC was detected -> no changes necessary
		// Calculated CRC is considered as correct
		return 0xFF ^ diff;
	}
	const uint8_t buf[SAM5_CRC8_MAX_DATA_LENGTH] = {0};
	const uint8_t crcTransmittedFull =
		(length == SAM5_CRC8_MAX_DATA_LENGTH) ? crcTransmitted
					   : sam5_sw_crc8_CRC_continue(buf, SAM5_CRC8_MAX_DATA_LENGTH - length, crcTransmitted);
	const uint8_t crcCalculatedFull =
		(length == SAM5_CRC8_MAX_DATA_LENGTH) ? crcCalculated
					   : sam5_sw_crc8_CRC_continue(buf, SAM5_CRC8_MAX_DATA_LENGTH - length, crcCalculated);
	const uint8_t diffFull = crcCalculatedFull ^ crcTransmittedFull;
	const uint8_t bitPos = sam5_sw_crc8_EccTable[diffFull];
	if (bitPos < SAM5_CRC8_MAX_DATA_LENGTH * 8) {
		// Fixable error was detected and length is smaller than SAM5_CRC8_MAX_DATA_LENGTH bytes which is
		// the maximum length where the ECC will work Transmitted CRC is considered
		// as correct
		data[bitPos / 8] ^= 1 << (bitPos % 8);
		return 0xFF;
	}
	return 0;
}

uint8_t sam5_sw_crc8_CRC(volatile const uint8_t *src, volatile uint32_t length) {
	return sam5_sw_crc8_CRC_continue(src, length, 0xFF);
}

uint8_t sam5_sw_crc8_CRC_continue(volatile const uint8_t *src, volatile uint32_t length, uint8_t init) {
	uint8_t crc = init;
	for (uint32_t i = 0; i < length; ++i) {
		uint8_t data = (uint8_t)(src[i] ^ crc);
		crc = (uint8_t)(sam5_sw_crc8_CrcTable[data]);
	}
	return crc;
}

